import java.lang.*;
import java.util.*;

/**
   Quick and dirty implementation of priority queue.  Uses
   BinaryPredicate (like JGL) to determine queue order. 
   add() operation is not efficient and should be replaced
   with a standard, efficient, heap implementation.
*/


public class PriorityQueue implements GeneralQueue {

   protected ArrayList<SearchNode> queue;
   protected BinaryPredicate comparator;

   public PriorityQueue(BinaryPredicate comparator) {
       queue = new ArrayList<SearchNode>();
       this.comparator = comparator;
   }

   public void add(SearchNode object) {
      int i;

      for (i=queue.size()-1; i>=0; i--) {
         if (comparator.evaluate(queue.get(i), object)) break;
      }

      queue.add(i+1, object);
   }

   public SearchNode removeFront() {
       int finalpos = queue.size() - 1;
      SearchNode object= queue.get(finalpos); 
      queue.remove(finalpos); 

      return object;
   }

   public boolean isEmpty() {
      return queue.size() == 0;
   }

}

